/*
    This file is part of Posixcpp library.

    Posixcpp library is free software: you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public License
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    Posixcpp library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with Posixcpp library. If not, see
    <http://www.gnu.org/licenses/>.
 */

#ifndef POSIX_IO_I2C_HPP
#define POSIX_IO_I2C_HPP

#include "posix_io_file.hpp"

POSIX_BEGIN_NAMESPACE

/**
 * @brief I2C file class
 */
class io::I2C : public io::File
{
public:

	I2C() = default;
	
	I2C(int);

	I2C(const std::string&);
	
	void setTimeout(posix::time::Timespec);
	
	void setRetries(unsigned long);
	
	void setSlave(unsigned long address, bool force=false);
	
	
};

POSIX_END_NAMESPACE

#endif /* POSIX_IO_I2C_HPP */
