/*
    This file is part of Posixcpp library.

    Posixcpp library is free software: you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public License
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    Posixcpp library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with Posixcpp library. If not, see
    <http://www.gnu.org/licenses/>.
 */


#ifndef POSIX_IO_PSEUDOTTY_HPP
#define POSIX_IO_PSEUDOTTY_HPP

#include "posix_io_tty.hpp"

POSIX_BEGIN_NAMESPACE
    
namespace io
{

class PseudoTTY : public TTY
{
public:
	
	PseudoTTY();
	
	void get();
	
	void open() override;
	
	void grant() const;
	
	void unlock() const;

	std::string slaveName() const;
};

}

POSIX_END_NAMESPACE

#endif
