/*
    This file is part of Posixcpp library.

    Posixcpp library is free software: you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public License
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    Posixcpp library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with Posixcpp library. If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef POSIX_THREADS_RWLOCK_HPP
#define	POSIX_THREADS_RWLOCK_HPP

#include "posix_threads.hpp"
#include "posix_threads_thread.hpp"

namespace posix
{
namespace threads
{

class RWLock
{
public:
	
	class Attributes final : public posixcpp::HandleWrapper<pthread_rwlockattr_t>
	{
	public:
		Attributes();
		
		void setPShared(ProcessShared_t);
		ProcessShared_t getPSHared();
	};
	
	RWLock(Attributes *attrs = NULL);
	
	~RWLock();
	
	const pthread_rwlock_t &handle() const
	{
		return _handle;
	}
	
	pthread_rwlock_t &handle()
	{
		return _handle;
	}
	
	void rdlock();
	
	void wrlock();
	
	void unlock();
	
private:
	/**
	 * POSIX threads manipulator
	 */
	pthread_rwlock_t _handle;
};

}
}

#endif	/* POSIX_THREADS_RWLOCK_HPP */
