/*
	This file is part of Posixcpp library.

	Posixcpp library is free software: you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public License
	as published by the Free Software Foundation, either version 3 of
	the License, or (at your option) any later version.

	Posixcpp library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with Posixcpp library. If not, see
	<http://www.gnu.org/licenses/>.
 */

#ifndef POSIX_TIME_HPP
#define	POSIX_TIME_HPP

#include <ctime>
#include <sys/time.h>
#include <ostream>

#include "posixcpp.hpp"
#include "posix_time_timespec.hpp"

namespace posix
{

namespace time
{

POSIXCPP_ENUM(Clock_t)
{
	NONE = 0
#ifdef CLOCK_MONOTONIC
	,MONOTONIC = CLOCK_MONOTONIC
#endif
#ifdef CLOCK_MONOTONIC
	,REALTIME = CLOCK_REALTIME
#endif
#ifdef CLOCK_PROCESS_CPUTIME_ID
	,PROCESS_CPU = CLOCK_PROCESS_CPUTIME_ID
#endif
#ifdef CLOCK_THREAD_CPUTIME_ID
	,THREAD_CPU = CLOCK_THREAD_CPUTIME_ID
#endif
#ifdef CLOCK_MONOTONIC_RAW
	,MONOTONIC_RAW = CLOCK_MONOTONIC_RAW
#endif
#ifdef CLOCK_MONOTONIC_RAW
	,REALTIME_COARSE = CLOCK_REALTIME_COARSE
#endif
#ifdef CLOCK_MONOTONIC_COARSE
	,MONOTONIC_COARSE = CLOCK_MONOTONIC_COARSE
#endif
};

std::ostream &operator <<(
  std::ostream & stream,
  Clock_t item);

}

}

#endif	/* POSIX_TIME_HPP */

